// Script de Alerte Joueur
using System;
using System.IO;
using System.Collections.Generic;
using maddox.game;
using maddox.core;
using maddox.game.world;
using maddox.GP;


public class Mission : AMission
{
    bool flag_Dron1 = false;
    bool flag_Dron2 = false;
    bool flagA_trigger = true;
    bool flagB_trigger = true;
    
    AiAction actionA, actionB;

    public override void OnTrigger(int missionNumber, string shortName, bool active)
    { 
    if ("triggerA".Equals(shortName) && active && flagA_trigger)
        {
            actionA = GamePlay.gpGetAction(ActorName.Full(missionNumber, "triggerA"));        
            flag_Dron1= true;
            flagA_trigger = false;
        }
     if ("triggerB".Equals(shortName) && active && flagB_trigger) //modif 4/11/2014
        {
            actionB = GamePlay.gpGetAction(ActorName.Full(missionNumber, "triggerB"));        
            flag_Dron2= true;
            flagB_trigger = false;
        }
    }

    public override void OnTickGame()
    {
        if (flag_Dron1)
        {
            if (actionA == null) { flag_Dron1 = false; return; }
                //GamePlay.gpHUDLogCenter("actionA");
                actionA.Do();
                flag_Dron1 = false;
        }
        if (flag_Dron2)
        {
            if (actionB == null) { flag_Dron2 = false; return; }
                //GamePlay.gpHUDLogCenter("actionB");
                actionB.Do();
                flag_Dron2 = false;           
        }
    }
    
}
