// Script de Entrainement 2

using System;
using System.Collections.Generic;

using maddox.game;
using maddox.core;
using maddox.game.world;
using maddox.GP;

public class Mission : AMission
{
  bool flag00_trigger = true;
  bool flag01_trigger = true;
  bool flag02_trigger = true;
  bool flag03_trigger = true;
  bool flag_atter = false;
  bool flag_J_leader = true;
  double x2, y2;

  public override void OnBattleStarted()
  {
    base.OnBattleStarted();
    if (!flag_J_leader) {GamePlay.gpHUDLogCenter("Suivez votre leader");}
  }
  public override void OnTrigger(int missionNumber, string shortName, bool active)
  {
    if ("trigger00".Equals(shortName) && active && flag00_trigger)
    {
      x2 = 291344.01; y2 = 214399.94;// valeurs du pt de route suivant
      if(flag_J_leader){ecritCap(x2, y2);}
      flag00_trigger = false;
    }
    if ("trigger01".Equals(shortName) && active && flag01_trigger)
    {
      x2 = 288030.88; y2 = 211000.69;// valeurs du pt de route suivant
      if(flag_J_leader){ecritCap(x2, y2);}
      flag01_trigger = false;
    }
    if ("trigger02".Equals(shortName) && active && flag02_trigger)
    {
      x2 = 280124.94; y2 = 207825.74;// valeurs du pt de route suivant
      if(flag_J_leader){ecritCap(x2, y2);}
      flag02_trigger = false;
    }
    if ("trigger03".Equals(shortName) && active && flag03_trigger)
    {
      x2 = 281477.75; y2 = 204061.44;// valeurs du pt de route suivant
      flag_atter = true;
      if(flag_J_leader){ecritCap(x2, y2);}
      flag03_trigger = false;
    }
  }
    public void ecritCap(double x2, double y2)
    {
        
        Player Joueur = GamePlay.gpPlayer();
        Point3d pos = Joueur.Place().Pos();
        double alpha = Teta(pos.x, pos.y, x2, y2);
        int capJoueur = Cap(alpha);
        //GamePlay.gpHUDLogCenter(" Joueur X:" + ((int)pos.x).ToString() + "  y:" + ((int)pos.y).ToString());
        if(flag_atter == true){GamePlay.gpHUDLogCenter(" Suivez le cap :" + capJoueur.ToString() + " puis atterrissez");}
        else {GamePlay.gpHUDLogCenter(" Suivez le cap :" + capJoueur.ToString());}

        
    }
    // ***** retourne un angle en rad, du vecteur AB avec l'axe des x  *****
    public double Teta(double xa, double ya, double xb, double yb)
    {
        double X, Y, angle;
        X = xb - xa;
        if (Math.Abs(X) < 0.001)
        {
            int s1 = Math.Sign(xa);
            int s2 = Math.Sign(xb);
            X = 0.001 * s1 * s2;
        }
        Y = yb - ya;
        angle = Math.Atan2(Y, X);
        if (X > 0.0 && Y > 0.0) { return angle; }
        if (X < 0.0 && Y > 0.0) { return angle; }
        if (X < 0.0 && Y < 0.0) { return Math.PI * 2.0 + angle; } //angle est <0 ds ce cas
        if (X > 0.0 && Y < 0.0) { return Math.PI * 2.0 + angle; } //angle est <0 ds ce cas
        else { return angle; }
    }
    // ***** calcule le cap en fonction de teta *****
    public static int Cap(double tetaRad)
    {
        int tetaDeg = (int)Math.Round((tetaRad * 180.0 / Math.PI), 0);
        int lecap = 0;
        if (90 >= tetaDeg) { lecap = 90 - tetaDeg; }
        if (tetaDeg >= 270) { lecap = 360 - tetaDeg + 90; }
        if (tetaDeg > 90 && tetaDeg <= 180) { lecap = 360 - tetaDeg + 90; }
        if (tetaDeg > 180 && tetaDeg < 270) { lecap = 360 - tetaDeg + 90; }
        return lecap;
    }
}

