// Script de Poursuite Bombers Axe 1

using System;
using System.Collections.Generic;
using maddox.game;
using maddox.core;
using maddox.game.world;
using maddox.GP;

public class Mission : AMission
{
    bool flag_trigger00 = true;
    bool flag_trigger01 = true;
    bool flag_leader_J = true;
    AiAction action01;
    double delta_T = 40; //en s
    double time_Top;
    double cibleX = 272388.23;
    double cibleY = 268672.84;
    int cap_Joueur = 0;
    string ch1_texte;

    public override void OnBattleStarted()
    {
        time_Top = Time.current() + delta_T;
        ch1_texte = "";
    }

    public override void OnTrigger(int missionNumber, string shortName, bool active)
    {
        if ("trigger00".Equals(shortName) && active && flag_trigger00)
        {
            if (flag_leader_J) { ch1_texte = "Suivez le cap : "; }
            else { ch1_texte = "Suivez le Leader, cap : "; }
           // GamePlay.gpHUDLogCenter(ch1_texte + cap_Joueur.Tostring());
            ecritCap(cibleX, cibleY);
            flag_trigger00 = false;
            ch1_texte = "Suivez le cap : ";
        }
        if ("trigger01".Equals(shortName) && active && flag_trigger01)
        {
            action01 = GamePlay.gpGetAction(ActorName.Full(missionNumber, "ASpawnBombersBlue"));
            action01.Do();
            flag_trigger01 = false;
        }
    }
    public override void OnTickGame()
    {
        // indication du cap ttes les delta_T secondes
        if (flag_leader_J && flag_trigger01)
        {
            // GamePlay.gpHUDLogCenter("");
            if (time_Top < Time.current() && ch1_texte !="")
            {
                ecritCap(cibleX, cibleY);
                time_Top = Time.current() + delta_T;
            }
        }
    }

    public void ecritCap(double x2, double y2)
    {
        Player Joueur = GamePlay.gpPlayer();
        Point3d pos = Joueur.Place().Pos();
        double alpha = Teta(pos.x, pos.y, x2, y2);
        cap_Joueur = Cap(alpha);
        GamePlay.gpHUDLogCenter(ch1_texte + cap_Joueur.ToString());
    }

    // ***** retourne un angle en rad, du vecteur AB avec l'axe des x  *****
    public double Teta(double xa, double ya, double xb, double yb)
    {
        double X, Y, angle;
        X = xb - xa;
        if (Math.Abs(X) < 0.001)
        {
            int s1 = Math.Sign(xa);
            int s2 = Math.Sign(xb);
            X = 0.001 * s1 * s2;
        }
        Y = yb - ya;
        angle = Math.Atan2(Y, X);
        if (X > 0.0 && Y > 0.0) { return angle; }
        if (X < 0.0 && Y > 0.0) { return angle; }
        if (X < 0.0 && Y < 0.0) { return Math.PI * 2.0 + angle; } //angle est <0 ds ce cas
        if (X > 0.0 && Y < 0.0) { return Math.PI * 2.0 + angle; } //angle est <0 ds ce cas
        else { return angle; }
    }

    // ***** calcule le cap (degre) en fonction de teta (radian) *****
    public static int Cap(double tetaRad)
    {
        int tetaDeg = (int)Math.Round((tetaRad * 180.0 / Math.PI), 0);
        int lecap = 0;
        if (90 >= tetaDeg) { lecap = 90 - tetaDeg; }
        if (tetaDeg >= 270) { lecap = 360 - tetaDeg + 90; }
        if (tetaDeg > 90 && tetaDeg <= 180) { lecap = 360 - tetaDeg + 90; }
        if (tetaDeg > 180 && tetaDeg < 270) { lecap = 360 - tetaDeg + 90; }
        return lecap;
    }
}
